function Aproximacion(X,M) %X vector que se quiere aproximar, M nmero de bloques 
N = length(X); 
if M > N, 
    error(['El numero de aproximaciones no debe exceder el numero de','valores originales']) 
end
if M == 1,
    disp(['Vector Optimo: [', num2str(mean(X)),']']) 
    disp(['Posiciones: [', num2str(N),']']) 
    disp(['Error Cuadratico: ', num2str(std(X)),'']) 
    return 
elseif M == N, 
    disp(['Vector Optimo: [', num2str(X),']']) 
    disp(['Posiciones: [', num2str(1:N),']']) 
    disp(['Error Cuadratico: ', num2str(0),'']) 
    return 
else
    TSet = nchoosek(1:N-1, M-1); 
end
IMax = size(TSet,1);
Z = zeros(1,M); 
EMin = Inf; 
Wb = waitbar(0, 'Calculando...'); 
for I = 1:IMax, T = TSet(I,:);
    E = 0;  
    for J = 1:M, 
        switch J 
            case 1
            Z(J) = mean(X(1:T(1)));
            E = E + sum((X(1:T(1))-Z(J)*ones(1,T(1))').^2); 
            case M 
                if T(M-1) ~= N, 
                    Z(J) = mean(X(T(M-1)+1:N));
                    E = E+sum((X(T(M-1)+1:N)-Z(J)*ones(1,N-T(M-1))').^2); 
                else Z(J) = 0; 
                end
            otherwise
                Z(J) = mean(X(T(J-1)+1:T(J)));
                E = E + sum((X(T(J-1)+1:T(J))-Z(J)*ones(1,T(J)-T(J-1))').^2);

        end
    end
    E = sqrt(E);
    if EMin > E,
        Y = Z;
        EMin = E;
        if T(1) ~= 1,
        TMin = [1,T]; 
        end
        if T(M-1) ~= N, 
            TMin = [T,N]; 
        end
    end
    waitbar(I/IMax, Wb);
end
close(Wb) 
disp(['Vector Optimo: [', num2str(Y),']']) 
disp(['Posiciones: [', num2str(TMin),']']) 
disp(['Error Cuadratico: ', num2str(EMin),''])